( 3iPiano.fs for 4x4 ports - AE - 2020-11-22---Sun---13:57 )

\ Hardware:
\   Piano     - 13 keys directly connected to Nano
\   Piano-4x4 - 13 keys connected to 4-bit port of Nano which triggers 74XXX which decodes the individual ids 
\   Piano-PCB - which works on the port concept 

: switchkey ( -- )  CALL_SWITCHKEY xcall ;  \ switch hardware modes

\ RECEIVE BUTTON PRESSES
: in4   11 10 9 8 ;  \ pins for input port, lsb on top of stack (8) 
12 constant CTRL-IN
\ SIGNAL LEDs
: out4  5 4 3 2 ;    \ pins for output port, lsb top of stack (2)

: init-piano
    out4 use-port-out 500 ms
    in4 port4in 500 ms
    2 piano-flash-n
    start-speaker
    ." OK" cr ;

$1B constant CALL_POLLPIANOKEY

: pollpianokey ( -- key ) \ wait till key is pressed.  
\ Uses new Nano instruction to fix problem that button 0 appears to be pressed falsely due to control line not being checked
    REG_PORTBIN xstore CTRL-IN xstore CALL_POLLPIANOKEY xcall
    begin 1 [Nread-com] until rcv-buffer c@ not4 ;  \ BLOCKING READ  \ uses not4 for active low

: loop-pollpianokey ( -- ) begin pollpianokey . 50 ms until ;
    
: prompt-light-test ( idx -- ) 
    dup piano-led-map + c@ _light_
    pollpianokey = if ." Match!" else ." Wrong!" then ;
    
: prompt-light-trial ( idx -- )   \ 0 indexed buttons
    cr dup . ." : " 
    begin dup dup __  ." __ "\  __
    pollpianokey 110 ms dup . = until drop ." Done!" ;  \ pause waits for sound to play

: prompt-light ( idx -- )   \ 0 indexed buttons
    begin dup dup __ pollpianokey 100 ms = until drop ;  \ pause waits for sound to play

\  create scale-led-map \ maps 1-8 to the appropriate lights, to match major key numbers
\      0 c, 2 c, 4 c, 5 c, 7 c, 9 c, 11 c, 12 c, \ white keys
\      1 c, 3 c, 6 c, 8 c, 10 c,                 \ black keys
\  : #_ ( scale# -- led# ) \ which led mapped code to turn on for scale based input
\      1 - scale-led-map + c@ ;
\  : #__ ( scale# -- ) #_ __ ; \ turn on appropriate light, scale based
\     
\  \ Sharps and Flats based on the 8-key numbering, with sharps and flats, indexed into the key-map above.
\  : 1# 9  ;
\  : 2% 9  ;
\  : 2# 10 ;
\  : 3% 10 ;
\  : 4# 11 ;
\  : 5% 11 ;
\  : 5# 12 ;
\  : 6% 12 ;
\  : 6# 13 ;
\  : 7% 13 ;
\  
\  : scale-light ( # -- )  \ 1 indexed buttons  -- see v26 3iSound-4x4.fs
\       #_ prompt-light ;
\  
\  
\  \ CODE REVIEW: Get to a musical data structure -- 3 arrays
\  \ play directly from stack, in reverse order
\  : play ( n -- ) dup 0 do dup i - roll .. loop drop ;
\   : watch ( n -- ) dup 0 do dup i - roll #__ 500 ms light| 100 ms loop drop light| ; \ 
\   : learn ( n -- ) dup 0 do dup i - roll scale-light 150 ms loop drop light| ; \ 

\ ========================================
: help-piano
  cr
  cr ." HELP-PIANO"
  cr ." ----------"
  cr 
  cr ." include 3iForth.fs 3iPort-4x4.fs 3iSound-4x4.fs 3iPiano.fs 3iSonglist.fs "
  cr 
  cr ." 1 open-com"
  cr ." INIT-PIANO"
  cr ." press buttons for sound"
  cr ." press Function C to toggle between equitemper (c std), bhairav (indian) and yu (chinese scales)"
  cr ." playlist: <name> play | watch | learn"
  cr
;

\ VERSION 1 - AE - 2020-11-22---Sun---14:37 - finished wiring the new PCB boards, including fixes with underneath
\ VERSION 2 - AE - 2020-11-27---Fri---20:02 - finished teach/learn mode
\ VERSION 3 - AE - 2020-11-28---Sat---21:34 - extended modes to play, watch, learn modes, including sharps and flats on numbers
